﻿using Frontify.Optimizely.Plugin.Interfaces;
using Frontify.Optimizely.Plugin.Models;

namespace Frontify.AlloyMvcTemplates.Frontify;

public class ArchiveFolderResolver : IFolderResolver
{
    private readonly IFrontifySettings _frontifySettings;

    public ArchiveFolderResolver(IFrontifySettings frontifySettings)
    {
        _frontifySettings = frontifySettings.GetCurrentInstance();
    }

    public ContentReference GetAssetFolder(FrontifyAsset asset)
    {
        if (_frontifySettings.RootFolderId == null)
        {
            throw new NullReferenceException("You haven't specified FrontifySettings for RootFolderId, please implement or set Frontify:RootFolderId in appsettings .");
        }

        if (string.IsNullOrEmpty(asset.name))//only integration test at first request //todo change this
        {
            return _frontifySettings.RootFolderId;
        }

        return _frontifySettings.RootFolderId;
    }
}