﻿using Frontify.Optimizely.Plugin.Interfaces;

namespace Frontify.AlloyMvcTemplates.Frontify;

public class ExampleSiteOneFrontifySettings : IFrontifySettings
{
    private readonly IConfiguration _configuration;
    public ExampleSiteOneFrontifySettings(IConfiguration configuration)
    {
        _configuration = configuration;
    }

    public virtual string AllowedTypes => _configuration["Frontify:AllowedTypes"] ?? ".jpg,.jpeg,.jpe,.gif,.bmp,.png";

    public virtual string ClientId => _configuration["Frontify:ClientId"];
    public string Domain => _configuration["Frontify:Domain"];

    public virtual int PreferredDownloadWidth
    {
        get
        {
            if (!int.TryParse(_configuration["Frontify:PreferredDownloadWidth"], out int size))
            {
                size = 0;
            }

            return size;
        }
    }

    public virtual int DefaultTinyMceImageWidth
    {
        get
        {
            if (!int.TryParse(_configuration["Frontify:DefaultTinyMceImageWidth"], out int size))
            {
                size = 0;
            }

            return size;
        }
    }

    public string ScriptUrl => _configuration["Frontify:ScriptUrl"];

    public virtual ContentReference RootFolderId

    {
        get
        {
            if (!int.TryParse(_configuration["Frontify:RootFolderId"], out var id))
            {
                throw new Exception("Frontify configuration not complete, Frontify:RootFolderId in appsettings  not set to a valid folder id");
            }
            return new ContentReference(id);
        }
    }

    public virtual bool DisableOptimizelyDefaultMediaSelector
    {
        get
        {
            if (!bool.TryParse(_configuration["Frontify:DisableOptimizelyDefaultMediaSelector"], out bool value))
            {
                value = false;
            }

            return value;
        }
    }

    public virtual bool EnableOnAllImages
    {
        get
        {
            if (!bool.TryParse(_configuration["Frontify:EnableOnAllImages"], out bool value))
            {
                value = true;
            }

            return value;
        }
    }
}